Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1282)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1285)
@@ -2936,4 +2936,14 @@
 }
 
+#if NH_3D_FIX_PRUNING
+Bool TComDataCU::hasEqualMotion( Int dirA, const TComMvField* mvFieldA, Int dirB, const TComMvField* mvFieldB )
+{
+  return  ( dirA == dirB  &&
+    ( ( dirA & 1 ) == 0 || mvFieldA[0] == mvFieldB[0]  ) &&
+    ( ( dirA & 2 ) == 0 || mvFieldA[1] == mvFieldB[1]  ) 
+    );
+}
+#endif
+
 #if NH_3D_VSP
 /** Add a VSP merging candidate
@@ -3038,5 +3048,9 @@
       if( !iLoop && ivCandDir[0] > 0)
       {
+#if NH_3D_FIX_PRUNING
+        if( hasEqualMotion(tmpDir, tmpMV, m_mergCands[MRG_IVMC].m_uDir, m_mergCands[MRG_IVMC].m_cMvField )) 
+#else
         if(tmpDir == m_mergCands[MRG_IVMC].m_uDir && m_mergCands[MRG_IVMC].m_cMvField[0]==tmpMV[0] && m_mergCands[MRG_IVMC].m_cMvField[1]==tmpMV[1])
+#endif
         {
             bRemove                         = true;
@@ -3487,9 +3501,13 @@
       for(iCnloop = 0; iCnloop < 2; iCnloop ++)
       {
-        if ( !m_mergCands[MRG_A1+iCnloop].m_bAvailable )  // prunning to A1, B1
+        if ( !m_mergCands[MRG_A1+iCnloop].m_bAvailable )  // pruning to A1, B1
         {
           continue;
         }
+#if NH_3D_FIX_PRUNING
+        if (hasEqualMotion( tmpDir, tmpMV, m_mergCands[MRG_A1+iCnloop].m_uDir, m_mergCands[MRG_A1+iCnloop].m_cMvField ) )
+#else
         if (tmpDir == m_mergCands[MRG_A1+iCnloop].m_uDir && tmpMV[0]==m_mergCands[MRG_A1+iCnloop].m_cMvField[0] && tmpMV[1]==m_mergCands[MRG_A1+iCnloop].m_cMvField[1])
+#endif
         {
           m_mergCands[MRG_A1+iCnloop].m_bAvailable = false;
@@ -3561,13 +3579,10 @@
       for(Int i = 0; i < 2; i ++)
       {
-        if ( !m_mergCands[MRG_A1 + i].m_bAvailable ) // prunning to A1, B1
+        if ( !m_mergCands[MRG_A1 + i].m_bAvailable ) // pruning to A1, B1
         {
           continue;
         }
 #if NH_3D_FIX_PRUNING
-        if  (   ivCandDir[0] == m_mergCands[MRG_A1+i].m_uDir                                &&
-            ( ( ivCandDir[0] & 1 ) == 0 || tmpMV[0]==m_mergCands[MRG_A1+i].m_cMvField[0]  ) &&
-            ( ( ivCandDir[0] & 2 ) == 0 || tmpMV[1]==m_mergCands[MRG_A1+i].m_cMvField[1]  ) 
-           )
+        if (hasEqualMotion(ivCandDir[0], tmpMV, m_mergCands[MRG_A1+i].m_uDir,  m_mergCands[MRG_A1+i].m_cMvField) )
 #else
         if (ivCandDir[0] == m_mergCands[MRG_A1+i].m_uDir && tmpMV[0]==m_mergCands[MRG_A1+i].m_cMvField[0] && tmpMV[1]==m_mergCands[MRG_A1+i].m_cMvField[1])
@@ -3579,11 +3594,8 @@
       }
     }
-    if (bIsDepth)
+    else
     {
 #if NH_3D_FIX_PRUNING
-      if  ( m_mergCands[MRG_T].m_bAvailable &&   ivCandDir[0] == m_mergCands[MRG_T].m_uDir  &&
-        ( ( ivCandDir[0] & 1 ) == 0 || tmpMV[0]==m_mergCands[MRG_T].m_cMvField[0]  ) &&
-        ( ( ivCandDir[0] & 2 ) == 0 || tmpMV[1]==m_mergCands[MRG_T].m_cMvField[1]  ) 
-        )
+      if( hasEqualMotion( ivCandDir[0], tmpMV, m_mergCands[MRG_T].m_uDir, m_mergCands[MRG_T].m_cMvField ) )
 #else
       if (m_mergCands[MRG_T].m_bAvailable && ivCandDir[0] == m_mergCands[MRG_T].m_uDir && tmpMV[0]==m_mergCands[MRG_T].m_cMvField[0] && tmpMV[1]==m_mergCands[MRG_T].m_cMvField[1])
@@ -3685,8 +3697,5 @@
       }
 #if NH_3D_FIX_PRUNING
-      if  ( ivCandDir[1] == m_mergCands[MRG_A1+i].m_uDir  &&
-        ( ( ivCandDir[1] & 1 ) == 0 || tmpMV[0]==m_mergCands[MRG_A1+i].m_cMvField[0]  ) &&
-        ( ( ivCandDir[1] & 2 ) == 0 || tmpMV[1]==m_mergCands[MRG_A1+i].m_cMvField[1]  ) 
-        )
+      if ( hasEqualMotion(ivCandDir[1], tmpMV, m_mergCands[MRG_A1+i].m_uDir, m_mergCands[MRG_A1+i].m_cMvField) )
 #else
       if (ivCandDir[1] == m_mergCands[MRG_A1+i].m_uDir && tmpMV[0]==m_mergCands[MRG_A1+i].m_cMvField[0] && tmpMV[1]==m_mergCands[MRG_A1+i].m_cMvField[1])
Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComDataCU.h	(revision 1282)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComDataCU.h	(revision 1285)
@@ -653,5 +653,7 @@
 
   Bool          hasEqualMotion              ( UInt uiAbsPartIdx, TComDataCU* pcCandCU, UInt uiCandAbsPartIdx );
-
+#if NH_3D_FIX_PRUNING
+  Bool          hasEqualMotion              ( Int dirA, const TComMvField* mvFieldA,  Int dirB, const TComMvField* mvFieldB  );
+#endif
 #if NH_3D_MLC
   Bool          getAvailableFlagA1() { return m_bAvailableFlagA1;   }
Index: branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComRom.cpp	(revision 1282)
+++ branches/HTM-14.1-update-dev1/source/Lib/TLibCommon/TComRom.cpp	(revision 1285)
@@ -686,10 +686,10 @@
   }
   Bool stopFlag = false; 
-  if ( g_stopAtPos && poc == 6 && layerId == 2 )
+  if ( g_stopAtPos && poc == 16 && layerId == 5 )
   {
     Bool stopAtCU = true; 
     if ( stopAtCU )        // Stop at CU with specific size
     {    
-      stopFlag = ( cuPelX  == 128 ) && ( cuPelY  == 160 ) && ( cuWidth == 32 ) && ( cuHeight == 32 ); 
+      stopFlag = ( cuPelX  == 224 ) && ( cuPelY  == 128 ) && ( cuWidth == 16 ) && ( cuHeight == 16 ); 
     }
     else